package uy.edu.fing.chesstrack.ajedrez;

import org.opencv.core.Core;
import org.opencv.core.CvType;
import org.opencv.core.Mat;
import org.opencv.core.Size;

public class Logica {
	private Mat _tableroInicio;
	private Mat _tableroAnterior;

	public Logica() {
		double[] vectorONES = { 1, 1, 1, 1, 1, 1, 1, 1 };
		_tableroInicio = Mat.zeros(new Size(8, 8), CvType.CV_8UC1);
		_tableroInicio.put(0, 0, vectorONES);
		_tableroInicio.put(1, 0, vectorONES);
		_tableroInicio.put(6, 0, vectorONES);
		_tableroInicio.put(7, 0, vectorONES);
		_tableroAnterior = _tableroInicio;
	}

	public Mat getTableroInicio() {
		return _tableroInicio;
	}

	public boolean validarNuevoTablero(Mat actual) {
		Mat result = new Mat(8, 8, CvType.CV_8UC1);
		Core.absdiff(actual, _tableroAnterior, result);
		if (Core.countNonZero(result) == 0) {
			_tableroAnterior = actual;
		}
		return (Core.countNonZero(result) != 0);
	}

	public boolean validarTableroArmado(Mat nuevo) {
		Mat result = new Mat(8, 8, CvType.CV_8UC1);
		Core.absdiff(nuevo, _tableroInicio, result);
		return (Core.countNonZero(result) == 0);
	}
}
