package uy.edu.fing.chesstrack.modulovision;

import org.opencv.calib3d.Calib3d;
import org.opencv.core.Mat;
import org.opencv.core.MatOfPoint2f;
import org.opencv.core.Rect;
import org.opencv.core.Size;

import android.util.Log;

public class Calibracion {
	private static final String TAG = "CHESSTRACK::Calibracion";

	private Size _sizeFrame = null;
	private MatOfPoint2f _vertices = null;
	private static Rect _rectROI = null;

	private static Calibracion _instance;

	protected Calibracion() {

	}

	public static Calibracion getInstance() {
		if (_instance == null) {
			_instance = new Calibracion();
		}
		return _instance;
	}

	public boolean calibrar(Mat img) {
		Log.i(TAG, "INI calibrando");

		Size patternSize = new Size(7, 7);
		MatOfPoint2f corners = new MatOfPoint2f();
		boolean ret = Calib3d.findChessboardCorners(img, patternSize, corners);
		if (ret) {
			Log.i(TAG, "Encontro = " + corners.total());
			// Calib3d.drawChessboardCorners(img, patternSize, corners, ret);
			// only for debug
			_vertices = corners;
			_sizeFrame = img.size();
		}
		Log.i(TAG, "FIN calibrando = " + ret);
		return ret;
	}

	public Size get_sizeFrame() {
		return _sizeFrame;
	}

	public void set_sizeFrame(Size _sizeFrame) {
		this._sizeFrame = _sizeFrame;
	}

	public MatOfPoint2f getVertices() {
		return _vertices;
	}

	public void setVertices(MatOfPoint2f vertices) {
		this._vertices = vertices;
	}

	public static Rect getRectROI() {
		return _rectROI;
	}

	public static void setRectROI(Rect rectROI) {
		Calibracion._rectROI = rectROI;
	}
}
